%define current_version 0.0.41

%global _hardened_build 1

Name:       disp-helper
Version:    %{current_version}
Release:        1%{?dist}
Summary:    Stat collector

Group:          Applications/Emulators
License:        GPLv2
ExclusiveArch:  x86_64
Source0:        %{name}-%{version}.tar.bz2
Source1:        %{name}.logrotate

Requires:       boost-date-time, boost-thread
Requires:       boost-filesystem, boost-program-options
Requires:       boost-system
Requires:       libcurl, libxml2, openssl
Requires:       python-lxml, python-configparser
Requires:       rsyslog
Requires:       disp-helper-config
BuildRequires:  make, cmake
BuildRequires:  gcc, gcc-c++
BuildRequires:  libcurl-devel, openssl-devel
BuildRequires:  libxml2-devel, boost-devel
BuildRequires:  systemd-devel

%description
CEP collector

%prep
%setup -q

%build
%cmake -DCMAKE_BUILD_TYPE=Debug -DCMAKE_INSTALL_PREFIX:PATH=%{buildroot}
%make_build

%install
%makeinstall
install -Dm644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

%post
%systemd_post disp-helper.service
# On the first installation, create crontab script for auto-update
# and enable the service
if [ $1 -eq 1 ] ; then
  DAY=$(( $RANDOM % 7 ))
  HOUR=$(( $RANDOM % 24 ))
  MINUTE=$(( $RANDOM % 60 ))
  echo "$MINUTE $HOUR * * $DAY root /usr/bin/yum -y update %{name} >> /var/log/disp-helper-update.log 2>&1" > /etc/cron.d/%{name}

  /bin/systemctl enable %{name}.service >/dev/null 2>&1 || :
  /bin/systemctl start %{name}.service >/dev/null 2>&1 || :
fi

%preun
%systemd_preun disp-helper.service

%postun
%systemd_postun_with_restart disp-helper.service
if [ $1 -eq 0 ] ; then
  rm -rf /etc/cron.d/%{name}
fi

%files
%defattr(-,root,root)
%attr(744,root,root) /usr/share/libexec/disp_helper
%attr(744,root,root) /usr/share/virtuozzo/cep-scripts/*.py
/usr/share/virtuozzo/cep-scripts/*.pyo
/usr/share/virtuozzo/cep-scripts/*.pyc
%attr(644,root,root) %{_unitdir}/disp-helper.service
%attr(644,root,root) %{_sysconfdir}/audit/rules.d/vz-audit.rules
%attr(644,root,root) %{_sysconfdir}/rsyslog.d/vz-log.conf
%attr(644,root,root) %{_libdir}/disp-helper-plugins/libcurl_plugin.so
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}

%changelog
* Tue Jun 20 2017 Denis Silakov <dsilakov@virtuozzo.com> 0.0.41
 - Limit the size of server reply in curl plugin, see #PSBM-65421 (Andrey
Bondrov <abondrov@virtuozzo.com>)
 - Exit from loop in exec_guest_command immidiately after out-data exceeds our
limit
 - Limit amount of data received by CEP scripts from VM guests, see #PSBM-65413

* Fri Jun 16 2017 Denis Silakov <dsilakov@virtuozzo.com> 0.0.40
 - One more memleak fix, see #PSBM-65414
 - Fix memleak, see #PSBM-65414 (Andrey Bondrov <abondrov@virtuozzo.com>)

* Thu Jun 08 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.39
 - Add list of hosts from VzPlatform cluster (Mikhail Feoktistov
<mfeoktistov@virtuozzo.com>)
 - Use UTC instead of local time (Mikhail Feoktistov
<mfeoktistov@virtuozzo.com>)

* Mon May 29 2017 Denis Silakov <dsilakov@virtuozzo.com> 0.0.38
 - Improve package collection in libvirt guests, see #PSBM-66652

* Wed May 24 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.37
 - Add more detailed exception logging (Denis Silakov <dsilakov@virtuozzo.com>)
 - Drop debug (Denis Silakov <dsilakov@virtuozzo.com>)
 - Specify access permissions for pid file directly (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Move platform guess command to guess_platform_cmd variable (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Formatting fixes to make python-flakes happy (#PSBM-65416) (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Formatting fixes to make python-flakes happy (#PSBM-65416) (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Drop unused variables in exception handling (found by pyflakes, #PSBM-65416)
(Denis Silakov <dsilakov@virtuozzo.com>)
 - Fix comparison with 'False' value (#PSBM-65416) (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Drop unused variables in exception handling (found by pyflakes, #PSBM-65416)
(Denis Silakov <dsilakov@virtuozzo.com>)
 - Fix import issues found by pyflakes (#PSBM-65416) (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Do not redefine external 'r' variable in internal loop (PSBM-60583) (Igor
Bazhitov <ibazhitov@virtuozzo.com>)
 - Explicitly set server verification options (PSBM-60583) (Igor Bazhitov
<ibazhitov@virtuozzo.com>)
 - Simplify temporary buffer management (PSBM-60583) (Igor Bazhitov
<ibazhitov@virtuozzo.com>)
 - Fix memleak with certca.data (PSBM-60583) (Igor Bazhitov
<ibazhitov@virtuozzo.com>)
 - Fix memleak on realloc(3) error (PSBM-60583) (Igor Bazhitov
<ibazhitov@virtuozzo.com>)

* Tue Apr 25 2017 Konstantin Volkov <wolf@virtuozzo.com> 0.0.36-2
- Drop cep-collector provides, see #PSBM-63866

* Mon Apr 24 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.36
 - Fix typo in getting stats script #PSBM-62681 (Nikolay Shirokovskiy
<nshirokovskiy@virtuozzo.com>)

* Fri Apr 21 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.35
 - Clear vz-events.log file instead of removing (#PSBM-64881)

* Fri Apr 14 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.34
 - Collect install-time Kernel command line from anaconda logs (#PSBM-64448)
 - Fix bug with .sent file from future (#PSBM-64481)

* Thu Apr 13 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.33
 - Remove useless code
 - Fix sending routine (#PSBM-63127 #PSBM-62662)
 - No need in no-reload (Denis Silakov <dsilakov@virtuozzo.com>)
 - Enable and start service during the first installation (#PSBM-63314) (Denis
Silakov <dsilakov@virtuozzo.com>)

* Thu Apr 13 2017 Denis Silakov <dsilakov@virtuozzo.com> 0.0.33-2
 - Enable and start service during the first installation (#PSBM-63314)

* Thu Apr 13 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.32
 - Fix ident (Denis Silakov <dsilakov@virtuozzo.com>)
 - More fixes for Linux guests (Denis Silakov <dsilakov@virtuozzo.com>)
 - Use python3 in libvirt_guests.py if python2 is not available (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Collect info for Linux guests (Denis Silakov <dsilakov@virtuozzo.com>)

* Wed Apr 12 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.31
 - Fix mistype
 - Add container processes to report (#PSBM-58497)
 - Add specific software to dedicated verbose list
 - Implement action logs collecting (#PSBM-58499)
 - Add rsyslog rule for VZ events (#PSBM-58499)

* Wed Apr 12 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.30
 - Add container processes to report (#PSBM-58497)
 - Add specific software to dedicated verbose list
 - Implement action logs collecting (#PSBM-58499)
 - Add rsyslog rule for VZ events (#PSBM-58499)

* Wed Apr 12 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.29
 - Add container processes to report (#PSBM-58497)
 - Add specific software to dedicated verbose list
 - Implement action logs collecting (#PSBM-58499)

* Tue Apr 11 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.28
 - Fix redeclaration of 'l' variable - due to this, ve.conf content was missing
in reports (#PSBM-64108) (Denis Silakov <dsilakov@virtuozzo.com>)

* Fri Mar 31 2017 Denis Silakov <dsilakov@virtuozzo.com> 0.0.27-2
 - Provide 'cep-collector' abstract

* Tue Mar 28 2017 Konstantin Volkov <wolf@virtuozzo.com> 0.0.27
 - Pick up OpenVZ cert if exists (#PSBM-62659) (Denis Silakov
<dsilakov@virtuozzo.com>)

* Fri Mar 24 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.26
 - Improve dlopen error logging
 - Fix scripts filenames check (#PSBM-62881)

* Thu Mar 23 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.25
 - Large scripts system rework (#PSBM-62688 #PSBM-40816)
 - Add copyrights and license ( #PSBM-58317 ) (Andrey Bondrov
<abondrov@virtuozzo.com>)

* Thu Mar 02 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.24
 - Add debug_results option
 - Slight refactoring and code rework

* Wed Mar 01 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.23
 - Fix bug with systemctl wrong main pid detection (#PSBM-61357)

* Tue Feb 28 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.22
 - Improve balancer (#PSBM-60660)
 - Add json extension to formed preliminary report part
 - Fix balancer (#PSBM-60660)

* Mon Feb 27 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.20
 - Remove pid file entry from disp-helper.service file (#PSBM-60661)
 - Add systemd notification (#PSBM-60661)

* Mon Feb 27 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.19-2
 - Add systemd-devel in build requirements

* Mon Feb 27 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.19
 - Fix disp-helper.service file (#PSBM-60661)

* Mon Feb 27 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.18
 - Add infrastructure script to installation

* Mon Feb 27 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.17
 - Fix default config path

* Mon Feb 27 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.16
 - Heavy rework script system (#PSBM-60661)
 - Fix plugin path, add extra logs

* Mon Feb 20 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.15
 - Fix fail in case of kpatch absence (#PSBM-60657)
 - Add audit rule (#PSBM-58496)
 - Add missed assignment operator
 - Remove unused header
 - Heavy reworking (#PSBM-60517)
 - Remove configuration file from install script
 - Small bunch of fixes
 - Libvirt guests info (#PSBM-40816)

* Mon Feb 20 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.14-2
 - Add audit rule file

* Mon Feb 20 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.14
 - Add missed assignment operator
 - Remove unused header
 - Heavy reworking (#PSBM-60517)
 - Remove configuration file from install script
 - Small bunch of fixes
 - Libvirt guests info (#PSBM-40816)
 - Remove deprecated dependencies
 - Fixed mistype
 - Fixed spec file and introduce sender plugin system
 - Fix sources version
 - Change license to GPLv2
 - Add disp-helper-config requirement

* Mon Feb 20 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.13
 - Add missed assignment operator
 - Remove unused header
 - Heavy reworking (#PSBM-60517)
 - Remove configuration file from install script
 - Small bunch of fixes
 - Libvirt guests info (#PSBM-40816)
 - Remove deprecated dependencies
 - Fixed mistype
 - Fixed spec file and introduce sender plugin system
 - Fix sources version
 - Change license to GPLv2
 - Add disp-helper-config requirement

* Mon Feb 20 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.12
 - Remove unused header
 - Heavy reworking (#PSBM-60517)
 - Remove configuration file from install script
 - Small bunch of fixes
 - Libvirt guests info (#PSBM-40816)
 - Remove deprecated dependencies
 - Fixed mistype
 - Fixed spec file and introduce sender plugin system
 - Fix sources version
 - Change license to GPLv2
 - Add disp-helper-config requirement

* Mon Feb 20 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.11-5
 - Add execution bit to disp_helper binary and all collector scripts
 - Make plugin sender system #PSBM-60517

* Tue Feb 14 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.11-4
 - Change license to GPLv2

* Tue Feb 14 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.11-3
 - Add disp-helper-config requirement

* Tue Feb 14 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.11-2
 - Fix permissions to binary and all collector scripts

* Mon Feb 13 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.11
 - Add OpenVZ switch marker to CEP report (#PSBM-31805)

* Mon Feb 13 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.10
 - Add libvirt statistics collector (#PSBM-60403)

* Fri Feb 10 2017 Denis Silakov <dsilakov@virtuozzo.com> 0.0.9-2
 - Create cron config for auto-update (#PSBM-39748)

* Thu Feb 09 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.9
 - Bunch of fixes
 - Fix autoformat errors

* Tue Feb 07 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.8
 - Fix autoformat errors

* Tue Feb 07 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.7
 - Improve data collecting scripts (#PSBM-45127 #PSBM-10305 #PSBM-46079)

* Fri Feb 03 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.6
 - Improve VE data collecting (#PSBM-58497)
 - Extend license info with owner_company and client_id
 - Fix disp_helper.json
 - Add kernel modules list (#PSBM-52232)
 - Add simfs info to CEP report (#PSBM-40737)

* Thu Feb 02 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.5-2
 - Add debug info and extend data collection

* Tue Jan 31 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.5
 - Stability improve and bugfixing (#PSBM-59469 #PSBM-59471)
 - A bunch of error fixes

* Fri Jan 27 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.4-2
 - A bunch of error fixes

* Fri Jan 27 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.4
 - Fix preliminary and finalresutls directories creation PSBM-59377 (Inga Pyass
<ipyass@virtuozzo.com>)
 - Fix installation of disp-helper.service file
 - Add disp-helper.service file

* Tue Jan 24 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.3-3
 - Fixed disp-helper.service file and fixed config file path

* Tue Jan 24 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.3-2
 - Fixed build requires section in spec file

* Tue Jan 24 2017 Alexander Burluka <aburluka@virtuozzo.com> 0.0.3
 - Fixed mistype in CMakeLists.txt

* Tue Jan 24 2017 Konstantin Volkov <wolf@virtuozzo.com> 0.0.2
 - Initial version (Alexander Burluka <aburluka@virtuozzo.com>)

* Tue Jan 24 2017 Alexander Burluka <aburluka@virtuozzo.com> - 0.0.1
- Initial changelog entry
